var Builder, Compiler, Files, Growl, Jasmine, Watcher, sys;
var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };
Watcher = require('./watcher');
sys = require('sys');
Growl = require('growl');
Files = require('./files');
Compiler = require('./compiler');
Jasmine = require('./jasmine');
Builder = module.exports = function(options) {
  this.config = options;
  this.files = new Files(this.config.directories.sources);
  this.specs = new Files('spec');
  this.watcher = new Watcher();
  this.compiler = new Compiler();
  this.jasmine = new Jasmine();
};
Builder.prototype.watch = function() {
  this.specs.on('files', __bind(function(list) {
    var file, _i, _len, _results;
    if (list) {
      _results = [];
      for (_i = 0, _len = list.length; _i < _len; _i++) {
        file = list[_i];
        _results.push(this.watcher.addFile(file));
      }
      return _results;
    }
  }, this));
  this.specs.watch();
  this.jasmine.on(Jasmine.SPECS_DONE, __bind(function(failed) {
    return Growl.notify(failed + " failures", {
      title: "[jasmine]"
    });
  }, this));
  this.compiler.on(Compiler.COMPILED, function(path) {
    return Growl.notify("Compiled " + path, {
      title: "[compiler]"
    });
  });
  this.watcher.on(Watcher.FILE_CHANGED, __bind(function(path) {
    this.path = null;
    if (path.indexOf('spec') === -1) {
      this.path = path;
    }
    if (this.config.specs) {
      this.jasmine.runAllSpecs();
    }
    return this.compiler.compile(this.path, this.config.directories.build);
  }, this));
  this.files.on('files', __bind(function(list) {
    var file, _i, _len, _results;
    if (list) {
      _results = [];
      for (_i = 0, _len = list.length; _i < _len; _i++) {
        file = list[_i];
        _results.push(this.watcher.addFile(file));
      }
      return _results;
    }
  }, this));
  this.files.watch();
  return Growl.notify("Starting v" + Builder.VERSION, {
    title: "[coffeemaker]"
  });
};
Builder.VERSION = "0.1.0";