var Compiler, Events, Watcher, spawn, sys;
var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };
Watcher = require('./watcher');
sys = require('sys');
spawn = require('child_process').spawn;
Events = require("events");
Compiler = module.exports = function() {
  return this.bareOutput = true;
};
sys.inherits(Compiler, Events.EventEmitter);
Compiler.prototype.compile = function(path, to) {
  var compiler, options;
  options = [];
  if (this.bareOutput) {
    options.push('-b');
  }
  options.push('-o', to);
  options.push('-c', path);
  compiler = spawn("coffee", options);
  compiler.stdout.on('data', function(data) {
    return sys.log(data);
  });
  compiler.stderr.on('data', function(data) {
    return sys.log(data);
  });
  return compiler.on('exit', __bind(function(code) {
    if (code === 0) {
      console.log('[compiler] ' + path + ' compiled');
      return this.emit(Compiler.COMPILED, path);
    }
  }, this));
};
Compiler.COMPILED = "compiled";