var Events, Files, Node, fs, sys;
var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };
fs = require('fs');
sys = require('sys');
Events = require("events");
Files = module.exports = function(dir) {
  this.files = [];
  this.dir = dir;
  this.node = new Node(this, this.dir);
  this.node.on('done', __bind(function(files) {
    this.files = files;
    return this.emit('files', this.files);
  }, this));
};
sys.inherits(Files, Events.EventEmitter);
Files.prototype.watch = function() {
  return setInterval(__bind(function() {
    return this.readFiles();
  }, this), 2000);
};
Files.prototype.readFiles = function() {
  return this.node.read();
};
Node = function(builder, path) {
  process.EventEmitter.call(this);
  this.builder = builder;
  this.path = path;
  this.stats = null;
  return this.dirCount = 0;
};
sys.inherits(Node, Events.EventEmitter);
Node.prototype.read = function() {
  return fs.stat(this.path, __bind(function(err, stats) {
    this.stats = stats;
    if (this.stats.isDirectory()) {
      return fs.readdir(this.path, __bind(function(err, files) {
        var file, _i, _len, _results;
        if (files.length === 0) {
          return this.doneHandler();
        } else {
          _results = [];
          for (_i = 0, _len = files.length; _i < _len; _i++) {
            file = files[_i];
            _results.push(this.addNode(this.path + "/" + file));
          }
          return _results;
        }
      }, this));
    } else {
      return this.emit('done', [this.path]);
    }
  }, this));
};
Node.prototype.addNode = function(path) {
  var node;
  this.dirCount++;
  node = new Node(this.builder, path);
  node.on('done', __bind(function(files) {
    return this.doneHandler(files);
  }, this));
  return node.read();
};
Node.prototype.doneHandler = function(files) {
  var file, _i, _len;
  if (files) {
    for (_i = 0, _len = files.length; _i < _len; _i++) {
      file = files[_i];
      this.addFile(file);
    }
  }
  if (--this.dirCount <= 0) {
    return this.emit('done', this.subFiles);
  }
};
Node.prototype.addFile = function(path) {
  if (!this.subFiles) {
    this.subFiles = [];
  }
  if (this.subFiles.indexOf(path) === -1) {
    return this.subFiles.push(path);
  }
};