var Events, Watcher, WatcherFile, fs, sys;
var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };
fs = require('fs');
sys = require('sys');
Events = require("events");
Watcher = module.exports = function() {
  return process.EventEmitter.call(this);
};
sys.inherits(Watcher, Events.EventEmitter);
Watcher.prototype.addFile = function(path) {
  var file;
  if (!this.files) {
    this.files = {};
  }
  if (this.files[path] !== void 0) {
    return;
  }
  file = new WatcherFile(path);
  file.on(WatcherFile.FILE_CHANGED, __bind(function(path) {
    return this.emit(Watcher.FILE_CHANGED, path);
  }, this));
  file.watch();
  this.files[path] = file;
  return console.log('[watcher] ' + path + ' added');
};
Watcher.prototype.removeFile = function(path) {
  this.files[path].stop();
  return this.files[path] = null;
};
Watcher.FILE_CHANGED = "fileChanged";
WatcherFile = function(path) {
  process.EventEmitter.call(this);
  return this.path = path;
};
sys.inherits(WatcherFile, Events.EventEmitter);
WatcherFile.prototype.watch = function() {
  return fs.watchFile(this.path, {
    persistent: true,
    interval: 500
  }, __bind(function(curr, prev) {
    if (!(curr.size === prev.size && curr.mtime.getTime() === prev.mtime.getTime())) {
      return this.emit(WatcherFile.FILE_CHANGED, this.path);
    }
  }, this));
};
WatcherFile.prototype.stop = function() {
  return fs.unwatchFile(this.path);
};
WatcherFile.FILE_CHANGED = "fileChanged";